// 组装模块并导出store的文件
import Vue from 'vue' // 引入vue
import Vuex from 'vuex' // 引入vuex
import getters from './getters' // 根级别的 getters

Vue.use(Vuex)

// 不再需要 `import xxx from './modules/xxx `，会自动从modules导入所有的vuex模块
const modulesFiles = require.context('./modules', true, /\.js$/)

const modules = modulesFiles.keys().reduce((modules, modulePath) => {
  const moduleName = modulePath.replace(/^\.\/(.*)\.\w+$/, '$1') // 获取文件名，例如 './app.js' => 'app'
  const value = modulesFiles(modulePath)
  modules[moduleName] = value.default
  return modules
}, {})

const store = new Vuex.Store({
  modules,
  getters
})

export default store // 导出store
